
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java程序员快速入门Go语言 / iVAN</title>

    <meta name="description" content="Java程序员快速入门Go语言 这篇文章帮助Java程序员快速入门Go语言. 转载至 开源中国社区. http://www.oschina.net 本文将以一个有代表性的例子为开始,以此让Java程序员对Go语言有个初步认识,随后将详细的描述Go语言的各个构成模块,最后以一个例子来讲解Go语言与Java语言的不同点.   先来认识堆栈(例子) 为了满足大家的好奇心,我们将开始于一个麻雀虽小但五脏内全的例子,这个例子将是Stack.java的Go语言版本. 01 //实现堆栈的包集合 02 package collection">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java程序员快速入门Go语言</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<table>
<tbody>
<tr>
<td>
<p><strong>这篇文章帮助Java程序员快速入门<a href="http://golang.org/" rel="external nofollow noreferrer">Go</a>语言。</strong></p>
<p><strong>转载至 开源中国社区。 <a href="http://www.oschina.net/" rel="external nofollow noreferrer">http://www.oschina.net</a></strong></p>
<p><strong>本文将以一个有代表性的例子为开始，以此让Java程序员对Go语言有个初步认识，随后将详细的描述Go语言的各个构成模块，最后以一个例子来讲解Go语言与Java语言的不同点</strong>。</p>
</td>
<td>
<a href="http://my.oschina.net/yale8848" rel="external nofollow noreferrer"> </a>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h2>先来认识堆栈（例子）</h2>
<p>为了满足大家的好奇心，我们将开始于一个麻雀虽小但五脏内全的例子，这个例子将是<a href="http://www.nada.kth.se/~snilsson/go_for_java_programmers/src/collection/Stack.java" rel="external nofollow noreferrer">Stack.java</a>的Go语言版本。</p>
<table>
<tbody>
<tr>
<td>
<code>01</code>
</td>
<td>
<code>//实现堆栈的包集合</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>02</code>
</td>
<td>
<code>package</code> <code>collection</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>03</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>04</code>
</td>
<td>
<code>//生成空堆栈</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>05</code>
</td>
<td>
<code>type<br />
 Stack struct {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>06</code>
</td>
<td>
<code>    </code><code>data<br />
 []</code><code>interface</code><code>{}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>07</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>08</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>09</code>
</td>
<td>
<code>//压栈顶</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>10</code>
</td>
<td>
<code>func<br />
 (s *Stack) Push(x </code><code>interface</code><code>{})<br />
 {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>11</code>
</td>
<td>
<code>    </code><code>s.data<br />
 = append(s.data, x)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>12</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>13</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>14</code>
</td>
<td>
<code>//弹栈顶，并删除栈顶</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>15</code>
</td>
<td>
<code>//如果是空栈将会引发运行时错误</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>16</code>
</td>
<td>
<code>func<br />
 (s *Stack) Pop() </code><code>interface</code><code>{}<br />
 {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>17</code>
</td>
<td>
<code>    </code><code>i<br />
 := len(s.data) - </code><code>1</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>18</code>
</td>
<td>
<code>    </code><code>res<br />
 := s.data[i]</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>19</code>
</td>
<td>
<code>    </code><code>s.data[i]<br />
 = nil  </code><code>//<br />
 to avoid memory leak</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>20</code>
</td>
<td>
<code>    </code><code>s.data<br />
 = s.data[:i]</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>21</code>
</td>
<td>
<code>    </code><code>return</code> <code>res</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>22</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>23</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>24</code>
</td>
<td>
<code>//返回栈大小</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>25</code>
</td>
<td>
<code>func<br />
 (s *Stack) Size() </code><code>int</code> <code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>26</code>
</td>
<td>
<code>    </code><code>return</code> <code>len(s.data)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>27</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<ul>
<li>用纯文本在声明语句上方添加注释。</li>
<li>申明的名字写在类型的后面。</li>
<li>结构体和Java中类相对应，但结构体的成员只能是变量，不能是方法。</li>
<li>interface{}类型对应Java中的Object。它不仅能代表引用类型，同时也能实现Go语言的所有类型。</li>
<li>(s *Stack)表示申明一个方法，s对应于Java中方法隐式传的this参数。</li>
<li>操作符：=表示申明和初始化一个变量，其类型由初始化语句决定。</li>
</ul>
<p></td>
<td>
<p> </p>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<p>下面是是使用collection.Stackabstract数据类型的简单例子。</p>
<table>
<tbody>
<tr>
<td>
<code>01</code>
</td>
<td>
<code>package</code> <code>collection_test</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>02</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>03</code>
</td>
<td>
<code>import</code> <code>(</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>04</code>
</td>
<td>
<code>    </code><code>collection </code><code>"."</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>05</code>
</td>
<td>
<code>    </code><code>"fmt"</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>06</code>
</td>
<td>
<code>)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>07</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>08</code>
</td>
<td>
<code>func<br />
 Example() {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>09</code>
</td>
<td>
<code>    </code><code>var<br />
 s collection.Stack</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>10</code>
</td>
<td>
<code>    </code><code>s.Push(</code><code>"world"</code><code>)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>11</code>
</td>
<td>
<code>    </code><code>s.Push(</code><code>"hello,<br />
 "</code><code>)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>12</code>
</td>
<td>
<code>    </code><code>for</code> <code>s.Size()<br />
 &gt; </code><code>0</code> <code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>13</code>
</td>
<td>
<code>        </code><code>fmt.Print(s.Pop())</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>14</code>
</td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>15</code>
</td>
<td>
<code>    </code><code>fmt.Println()</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>16</code>
</td>
<td>
<code>    </code><code>//<br />
 Output: hello, world</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>17</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>将测试包package colloection_test和collectionpackage放在同一目录。第一个import声明“.”表示将要用当前路径中的包并同时命名为collection，“fmt”是标准库的包名，没有重新命名，所以就直接用包名fmt即可。
</td>
<td>
<a href="http://my.oschina.net/yale8848" rel="external nofollow noreferrer"> </a>  </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h2>概念上的不同点</h2>
<ul>
<li>Go没有类的构造器。Go提供<a href="http://www.nada.kth.se/~snilsson/go_for_java_programmers/#Structs" rel="external nofollow noreferrer">结构体</a>和<a href="http://www.nada.kth.se/~snilsson/go_for_java_programmers/#Methods_and_interfaces" rel="external nofollow noreferrer">接口</a>，类的继承以及动态方法查询来进行实例化，而非通过实例方法。接口同样用于Java中的泛型。</li>
<li>Go中不仅对象和数组可以有指向数据的指针，其它所有类型都有。对于任何类型T，都有一个指针类型*T与之相对应，其表明<a href="http://www.nada.kth.se/~snilsson/go_for_java_programmers/#Pointers" rel="external nofollow noreferrer">指向</a>类型为T的值。</li>
<li>Go允许在任何类型上创建方法；方法的接收者，就是Java中this，可以是个值或是指针。</li>
<li>数组在Go中是一些值。当数组作为函数参数传递时，函数将收到数组值的拷贝，不是指针。然而实际中，经常用slices作为参数；因为切片中有数组的引用。</li>
<li>Go中提供字串类型；字串就像是由比特序列构成的<a href="http://www.nada.kth.se/~snilsson/go_for_java_programmers/#Slices" rel="external nofollow noreferrer">slices</a>，但字串是不可变的。</li>
<li>在Go中哈希表叫maps。</li>
<li>Go提过<a href="http://www.nada.kth.se/~snilsson/go_for_java_programmers/#Goroutines" rel="external nofollow noreferrer">channels</a>类型来在多线程，<a href="http://www.nada.kth.se/~snilsson/go_for_java_programmers/#Goroutines" rel="external nofollow noreferrer">goroutines</a>之间通信来实现并发。</li>
<li>一般类型（maps,slices,channels）传参是引用，不是值。如果传参map，参数不是对map的值拷贝；如果函数里改变了map的值，函数调用者的map也将改变。这个和Java中map类似。</li>
<li>Go中访问权限有两种，和Java中public<br />
 和包private类似。如果声明的名称首字母大写就是public，否则就是包private。</li>
<li>Go用<a href="http://www.nada.kth.se/~snilsson/go_for_java_programmers/#Errors" rel="external nofollow noreferrer">error</a>类型取代Java中的异常，诸如访问文件到结尾、运行时刻<a href="http://www.nada.kth.se/~snilsson/go_for_java_programmers/#Panic" rel="external nofollow noreferrer">panic</a>，数组越界等等。</li>
<li>Go不支持隐式类型转换，必须是显式的。</li>
<li>Go不支持覆盖。函数名和方法名在同一作用域必须不同。</li>
<li>Go用nil表示空指针，而Java用null。</li>
</ul>
<p></td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<p>语法</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTMwNy8xMDE4MTY0MV9pRGZuLmpwZw==.jpg"></p>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<br />
当声明函数时,你必须为每个参数提供一个名称，或者不为任何参数提供名称;你不能省略一些参数的名称并提供其它参数的名称。你可以用相同的类型来组织几个名字，例如:</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>func<br />
 f(i, j, k </code><code>int</code><code>,<br />
 s, t string)</code>
</td>
</tr>
</tbody>
</table>
<p>一个变量可以在声明它时初始化值。进行此操作时,可以指定变量的类型,但这并非必需的。当不指定类型时,则默认为初始化表达式的类型。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>var<br />
 v9 = *v2</code>
</td>
</tr>
</tbody>
</table>
<p>如果一个变量没有明确地初始化,则必须指定其类型。在这种情况下，它将隐式地初始化为其类型的零值(0，nil 等)。在Go语言中没有其它某些语言中的未初始化的变量。</p>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h3>短声明</h3>
<p>在函数内，可以用 := 进行短声明，比如：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>v10<br />
 := v1</code>
</td>
</tr>
</tbody>
</table>
<p>它等效于：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>var<br />
 v10 = v1</code>
</td>
</tr>
</tbody>
</table>
<h3>函数类型</h3>
<p>在Go语言中，函数是一等公民。Go的函数类型表示有相同的参数和结果类型的所有函数的集合。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>type<br />
 binOp func(</code><code>int</code><code>, </code><code>int</code><code>) </code><code>int</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>var<br />
 op binOp</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>add<br />
 := func(i, j </code><code>int</code><code>) </code><code>int</code> <code>{ </code><code>return</code> <code>i<br />
 + j }</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>6</code>
</td>
<td>
<code>op<br />
 = add</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>7</code>
</td>
<td>
<code>n<br />
 = op(100, 200)  </code><code>//<br />
 n = 100 + 200</code>
</td>
</tr>
</tbody>
</table>
</td>
<td>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h3>多重赋值</h3>
<p>Go 允许多重赋值。右边的表达式先被求值然后赋给左边的操作数。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>i,<br />
 j = j, i  </code><code>//<br />
 交换 i 和 j 的值（不用象传统语言中需要第三个临时变量）.</code>
</td>
</tr>
</tbody>
</table>
<p>函数可以有多个返回值，用参数括号后面的一个括号中的列表表示。返回值通过赋予一个变量列表来存储，如：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>func<br />
 f() (i </code><code>int</code><code>,<br />
 pj *</code><code>int</code><code>)<br />
 { ... }</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>v1,<br />
 v2 = f()</code>
</td>
</tr>
</tbody>
</table>
<h3>空标识符</h3>
<p>空标识符用下划线字符表示,它提供了一种方法来忽略由多值表达式返回的某个值，如：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>v1,<br />
 _ = f()  </code><code>//<br />
 忽略f()返回的第二个值.</code>
</td>
</tr>
</tbody>
</table>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h3>分号和格式</h3>
<p>不需要担心分号和格式，你可以用 gofmt程序创建一个标准的Go样式。虽然这个样式最初看起来或许有点古怪，但它同任何其它样式一样的好，而且熟悉以后会感觉越来越舒服。</p>
<p>在实践中Go代码使用分号不多。严格说，所有的Go语句都是由分号终止。不过，Go在非空白行的末尾隐式插入一个分号，除非该行明显未结束。这带来的影响是，在某些情况下Go不允许换行符。例如，你不能这么写</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>func<br />
 g()</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>{            </code><code>//<br />
 INVALID; "{" should be on previous line.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>g()后面会插入一个分号，使它成为一个函数声明，而不是函数定义。类似的，你也不能写</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>if</code> <code>n<br />
 == 0 {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>else</code> <code>{       </code><code>//<br />
 INVALID; "else {" should be on previous line.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p> }后面else前面会插入一个分号，导致语法错误。</p>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h3>条件语句</h3>
<p>Go 不使用括号来包裹 if 语句中的条件,和 for 语句中的表达式, 以及 switch 语句中的值。但另一方面,它必须用花括号来包裹 if 或 for 的执行语句体。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>if</code> <code>a<br />
 &lt; b { f() }</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>if</code> <code>(a<br />
 &lt; b) { f() }           </code><code>//<br />
 不需要括号.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>if</code> <code>(a<br />
 &lt; b) f()               </code><code>//<br />
 非法(执行体未用花括号括起来)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>for</code> <code>i<br />
 = 0; i &lt; 10; i++ {}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>for</code> <code>(i<br />
 = 0; i &lt; 10; i++) {}  </code><code>//<br />
 非法(表达式不需要括起来)</code>
</td>
</tr>
</tbody>
</table>
<p>此外,if 和 switch 接受一个可选的初始化语句，通常用它建立一个局部变量，如：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>if</code> <code>err<br />
 := file.Chmod(0664); err != nil {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>    </code><code>log</code><code>.Print(err)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>    </code><code>return</code> <code>err</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h3>For 语句</h3>
<p>Go 不具有 while 语句，也没有 do-while 语句。可以赋以for语句一个单一条件，使其与while语句等效。完全省略条件会制造一个无限循环。</p>
<p>for语句可能包含一个范围条件，对strings, arrays, slices, maps, 或 channels进行迭代。除了这么写</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>for</code> <code>i<br />
 := 0; i &lt; len(a); i++ { ... }</code>
</td>
</tr>
</tbody>
</table>
<p>要循环遍历a的元素，我们也可以这么写</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>for</code> <code>i,<br />
 v := range a { ... }</code>
</td>
</tr>
</tbody>
</table>
<p>这会将i作为索引，给v赋以一个array, slice, 或 string中的连续元素。对于字符串，i是对单一字节的索引，v是一个符文类型的Unicode代码点（符文是int32的一个别名）。对maps迭代会产生键值对，而对channels则只会产生一个迭代值。</p>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<p>Break和Continue</p>
<p>像Java一样，Go允许使用break和continue来指定标签（label），但是这个标签所引用的必须是一个for、switch或者select语句。</p>
<h2>Switch语句</h2>
<p>在一个switch语句中，case标签默认不会往下传递（fall through，也就是在没有break的情况下也不会执行后续case的程序），但是你能够通过使用一个向下传递（fallthrough）语句来使得它们可以向下传递。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>switch</code> <code>n<br />
 {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>case</code> <code>0:  </code><code>//<br />
 empty case body</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>case</code> <code>1:</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>    </code><code>f()  </code><code>//<br />
 f is not called when n == 0.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>但是一个case能够有多个值：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>switch</code> <code>n<br />
 {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>case</code> <code>0,<br />
 1:</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>    </code><code>f()  </code><code>//<br />
 f is called if n == 0 || n == 1.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>case后面的值可以是支持相等比较（equality comparison）操作符的任何类型，比如string或者pointer。缺省的switch表达式等效于true表达式：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>switch</code> <code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>case</code> <code>n<br />
 &lt; 0:</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>    </code><code>f1()</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>case</code> <code>n<br />
 == 0:</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>    </code><code>f2()</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>6</code>
</td>
<td>
<code>default</code><code>:</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>7</code>
</td>
<td>
<code>    </code><code>f3()</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>8</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h3>++ 和 -- 语句</h3>
<p>++ 和 --只能被用作语句中的后缀操作符，而不能用在表达式中。例如，你不能再这样写了： n = i++。</p>
<h3>defer 语句</h3>
<p>defer语句用来调用一个函数，但将其执行延迟到上一个附近的函数返回之后的时刻。被延迟的函数的执行与附近函数返回采取的路径无关。然而,当defer语句执行时，被延迟函数的参数已经被计算并保存以供之后使用。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>f,<br />
 err := os.Open(</code><code>"filename"</code><code>)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>defer<br />
 f.Close()  </code><code>//<br />
 当上个函数返回后，f 会被关闭.</code>
</td>
</tr>
</tbody>
</table>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h2>常量</h2>
<p>在 Go 中常量可以是无类型的。这适用于数值常量,只使用无类型常量的表达式,以及没有给出类型和初始化表达式是无类型的常量声明。当一个无类型的常量被用于一个需要类型化的值的环境中,它的值会转换成类型化的。所以即使 Go 没有隐式的类型转换，这也能允许常量被相对自由地使用。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>var<br />
 a uint</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>f(a<br />
 + 1)    </code><code>//<br />
 无类型的数字常量 1 成为 uint 类型.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>f(a<br />
 + 1e3)  </code><code>//<br />
 1e3 也作为 uint 类型.</code>
</td>
</tr>
</tbody>
</table>
<p>语言在无类型的数值常数的大小上不强加任何限制。 只有当一个常数被用在需要一个有类型的值时才会根据该类型对大小有所限制，如：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>const</code> <code>huge<br />
 = 1 &lt;&lt; 100</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>var<br />
 n </code><code>int</code> <code>=<br />
 huge &gt;&gt; 98</code>
</td>
</tr>
</tbody>
</table>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<p>如果在一个类型声明中类型关键字缺失，而相关的表达式计算出来是一个非类型（untyped）的数字常量，这个常量就会被分别转换成rune、int、float64、或者complex128类型，取决于这个值是否是一个字符（character）、整形（integer）、浮点型（float-point）还是复杂型（complex）的常量。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>c<br />
 := </code><code>'å'</code>      <code>//<br />
 rune (alias for int32)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>n<br />
 := 1 + 2    </code><code>//<br />
 int</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>x<br />
 := 2.7      </code><code>//<br />
 float64</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>z<br />
 := 1 + 2i   </code><code>//<br />
 complex128</code>
</td>
</tr>
</tbody>
</table>
<p>Go没有枚举（enumerate）类型。取而代之，你可以在一个单独的常量（const）声明中使用特殊的名字iota来获得一系列增长的值。当一个初始化表达简化成一个常量时，它就会重用前面的表达式。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>const</code> <code>(</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>    </code><code>red<br />
 = iota  </code><code>//<br />
 red == 0</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>    </code><code>blue        </code><code>//<br />
 blue == 1</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>    </code><code>green       </code><code>//<br />
 green == 2</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>)</code>
</td>
</tr>
</tbody>
</table>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h2>结构</h2>
<p>结构对应于 Java 中的类，但结构的成员不能是方法，只能是变量。结构指针类似 Java 中的引用变量。与 Java 的类不同,结构也可以被定义为直接值。对于结构和结构指针都可以使用“.”来访问结构中的成员，如：</p>
<table>
<tbody>
<tr>
<td>
<code>01</code>
</td>
<td>
<code>type<br />
 MyStruct </code><code>struct</code> <code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>02</code>
</td>
<td>
<code>    </code><code>s<br />
 string</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>03</code>
</td>
<td>
<code>    </code><code>n<br />
 int64</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>04</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>05</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>06</code>
</td>
<td>
<code>var<br />
 x MyStruct      </code><code>//<br />
 x 被初始化为 MyStruct{"", 0}.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>07</code>
</td>
<td>
<code>var<br />
 px *MyStruct    </code><code>//<br />
 指针 px 初始化为 nil.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>08</code>
</td>
<td>
<code>px<br />
 = </code><code>new</code><code>(MyStruct)  </code><code>//<br />
 px 指向新结构体 MyStruct{"", 0}.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>09</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>10</code>
</td>
<td>
<code>x.s<br />
 = </code><code>"Foo"</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>11</code>
</td>
<td>
<code>px.s<br />
 = </code><code>"Bar"</code>
</td>
</tr>
</tbody>
</table>
<p>在 Go 中，方法可以与任意命名类型有关，不只与结构; 参考<a href="http://www.nada.kth.se/~snilsson/go_for_java_programmers/#Methods_and_interfaces" rel="external nofollow noreferrer">方法和接口的讨论</a>.</p>
</td>
<td>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h3>指针</h3>
<p><a href="http://www.flickr.com/photos/lwr/374707207/" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTMwNy8xMDE4MTY1Ml9Hak9NLmpwZw==.jpg"></a></p>
<p>如果你有一个整数或一个结构或一个数组,赋值会复制对象的内容。Go 使用指针来实现 Java 的引用变量的效果。对于任意类型T,有一个相应的指针类型*T,表示指向类型T的值。</p>
<p>要为一个指针变量分配存储空间,要使用内置函数 new,它接受一个类型并返回一个指向已分配存储空间的指针。分配的空间将根据类型进行零初始化。 例如,new(int)为一个新int分配存储空间,初始值为0,并返回它的地址,类型为*int。</p>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<p>在Java代码 T p = new T()中，T是一个带有两个int类型实体变量a和b的类，对应于：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>type<br />
 T </code><code>struct</code> <code>{<br />
 a, b </code><code>int</code> <code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>var<br />
 p *T = </code><code>new</code><code>(T)</code>
</td>
</tr>
</tbody>
</table>
<p>或者更地道的：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>p<br />
 := </code><code>new</code><code>(T)</code>
</td>
</tr>
</tbody>
</table>
<p>声明语句 var v T 声明了一个装着类型T的值的变量，在Java中没有相匹配的语句。值也可以使用一种复合语法来创建或者初始化，例如：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>v<br />
 := T{1, 2}</code>
</td>
</tr>
</tbody>
</table>
<p>等效于：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>var<br />
 v T</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>v.a<br />
 = 1</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>v.b<br />
 = 2</code>
</td>
</tr>
</tbody>
</table>
<p>对于类型T的一个操作数x，寻址操作符 &amp;x 提供x的地址，它是类型*T的一个值。例如：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>p<br />
 := &amp;T{1, 2} </code><code>//<br />
 p has type *T</code>
</td>
</tr>
</tbody>
</table>
<p>对于指针类型的一个操作数x，指针指向（pointer indirection）通过x用*x表示所指向的值。指针指向是很少被用到的；而Go像Java一样，能够自动获取到一个变量的地址：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>p<br />
 := </code><code>new</code><code>(T)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>p.a<br />
 = 1 </code><code>//<br />
 equivalent to (*p).a = 1</code>
</td>
</tr>
</tbody>
</table>
</td>
<td>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<p>Slices</p>
<p>一个slice是一个含有3个域的结构体：一个指向数组的指针，一个长度，一个容量大小。Slices可以用[]来访问数组元素。内置的len函数返回slice的长度，cap函数返回容量大小。</p>
<p>创建一个新的slice，可以用给定数组或slice a，通过a[i:j]的方式创建。新创建的slice是对a的引用，并且内容用是从a内容的索引的i到索引j。它的长度是j-i。如果i缺省，其slice开始于0，j缺省表示len(a)。新的slice是原来a的引用，如果改变了新slice里元素的值，a也会改变。新slice的容量是a的容量减去i。其数值的容量是原数值的长度。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>var<br />
 s[]</code><code>int</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>var<br />
 a[</code><code>10</code><code>]</code><code>int</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>s=a[:]</code><code>//s=a[0:len(a)]的简写</code>
</td>
</tr>
</tbody>
</table>
<p>如果创建了一个数[100]byte(100bytes的数组，也许用作缓存区),并且想将它传递给一个函数，那么可以将函数的参数设置为[]byte类型，这样就会传递一个slice。slice也可以通过make函数来创建(如下有描述)。</p>
<p>和Java中的ArrayList用法一样，slice也内建append函数。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>s0:=[]</code><code>int</code><code>{</code><code>1</code><code>,</code><code>2</code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>s1:=append(s0,</code><code>3</code><code>)</code><code>//添加一个单元素</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>s2:=append(s1,</code><code>4</code><code>,</code><code>5</code><code>)</code><code>//添加多元素</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>s3:=append(s2,s0...)</code><code>//添加slice</code>
</td>
</tr>
</tbody>
</table>
<p>slice也能用于string，它将返回子字符串。
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h3>初始化</h3>
<p>Map和channel的值必须用内建的函数make来申请值。例如，用</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>make(map[string]</code><code>int</code><code>)</code>
</td>
</tr>
</tbody>
</table>
<p>将得到一个类型为map[string]int类型的值。于用new不同，make将返回对象值而不是地址。这样就于map和channel为引用类型就保持一致了。<br />
<br />对于map，make函数提供一个隐含可选的第二个参数。对于channel，也有第二个可选参数，它是用来设置channel缓冲区的大小；默认是0（没有缓冲区）。</p>
<p>make函数也能为slice来申请值。那样将申请一个隐藏在slice里数组，而返回的是指向它的slice引用。此时用make需要一个slice元素个数的参数。第二个可选参数是slice的容量。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>m:=make([]</code><code>int</code><code>,</code><code>10</code><code>,</code><code>20</code><code>)</code><code>//于new([20]int)[:10]相同</code>
</td>
</tr>
</tbody>
</table>
</td>
<td>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<p>方法和接口</p>
<h2>方法</h2>
<p>方法像是一个普通的函数定义，除非它有一个接收器（receiver）。接收器类似于Java实体方法中的this引用。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>type<br />
 MyType </code><code>struct</code> <code>{<br />
 i </code><code>int</code> <code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>func<br />
 (p *MyType) Get() </code><code>int</code> <code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>    </code><code>return</code> <code>p.i</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>6</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>7</code>
</td>
<td>
<code>var<br />
 pm = </code><code>new</code><code>(MyType)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>8</code>
</td>
<td>
<code>var<br />
 n = pm.Get()</code>
</td>
</tr>
</tbody>
</table>
<p>这里定义了一个同MyType联系起来的Get方法。名为p的接收器在函数体之中。</p>
<p>方法被定义在有命名的类型中。如果转换成不同类型的值，新的值将会拥有新类型的方法，而不是原有类型的那些方法。</p>
<p>你也许会在一个内建的类型中定义方法，通过声明一个继承自它的新命名的类型。新的类型同内建的类型是不同的。</p>
<table>
<tbody>
<tr>
<td>
<code>01</code>
</td>
<td>
<code>type<br />
 MyInt </code><code>int</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>02</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>03</code>
</td>
<td>
<code>func<br />
 (p MyInt) Get() </code><code>int</code> <code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>04</code>
</td>
<td>
<code>    </code><code>return</code> <code>int</code><code>(p)  </code><code>//<br />
 The conversion is required.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>05</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>06</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>07</code>
</td>
<td>
<code>func<br />
 f(i </code><code>int</code><code>)<br />
 {}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>08</code>
</td>
<td>
<code>var<br />
 v MyInt</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>09</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>10</code>
</td>
<td>
<code>v<br />
 = v * v          </code><code>//<br />
 The operators of the underlying type still apply.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>11</code>
</td>
<td>
<code>f(</code><code>int</code><code>(v))          </code><code>//<br />
 int(v) has no defined methods.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>12</code>
</td>
<td>
<code>f(v)               </code><code>//<br />
 INVALID</code>
</td>
</tr>
</tbody>
</table>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<p>接口</p>
<p>Go的接口同Java的接口类似，但任何提供了用一个Go接口命名的方法的类型，都可以被看做是对那个接口的实现。不需要额外的声明了。</p>
<p>给定下面这个接口：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>type<br />
 MyInterface interface {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>    </code><code>Get() </code><code>int</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>    </code><code>Set(i </code><code>int</code><code>)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>由于MyType已经有了一个Get方法，我们能够让Mytype满足这个接口的要求，通过添加：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>func<br />
 (p *MyType) Set(i </code><code>int</code><code>)<br />
 {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>    </code><code>p.i<br />
 = i</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>现在任何使用MyInterface作为参数的函数，将可以接受 *MyType类型的变量：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>func<br />
 GetAndSet(x MyInterface) {}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>func<br />
 f1() {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>    </code><code>var<br />
 p MyType</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>    </code><code>GetAndSet(&amp;p)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>6</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>在Java中，为*MyType类型定义Set和Get，就会让*MyType自动实现了MyInterface。一个类型可以满足多个接口。这是一种鸭式类型（duck typing）的形式。</p>
<blockquote><p>当我看到一只鸟儿走起路来像鸭子，游起来也像鸭子，呱呱的叫起来也像鸭子，我就会把这只鸟儿称作鸭子.</p></blockquote>
<p>James Whitcomb Riley
</td>
<td>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td rowspan="2">
<br />
匿名域 </p>
<p>匿名域和Java中的子类类似.</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>type<br />
 MySubType struct {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>    </code><code>MyType</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>    </code><code>j </code><code>int</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>6</code>
</td>
<td>
<code>func<br />
 (p *MySubType) Get() </code><code>int</code> <code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>7</code>
</td>
<td>
<code>    </code><code>p.j++</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>8</code>
</td>
<td>
<code>    </code><code>return</code> <code>p.MyType.Get()</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>9</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>MySubType是作为MyType的子类。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>func<br />
 f2() {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>    </code><code>var<br />
 p MySubType</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code> </code> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>    </code><code>GetAndSet(&amp;p)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>Set方法继承于MyType，在闭合类型中的匿名域的方法可以提升为闭合类型的方法。也就是说，MyType做为MySubType的匿名域，MyType中的方法MySubType都能用。Get方法是覆盖方法，Set方法是继承来的。 <br />
匿名域和也不是和Java中的子类完全一样。当调用匿名域的方法，方法的接收者是匿名域而不是闭合类型。也就是说，匿名域的方法不会动态分发。如果想实现Java中的动态方法looup，就等用interface。 </p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>func<br />
 f3() {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>    </code><code>var<br />
 v MyInterface</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>    </code><code>v<br />
 = </code><code>new</code><code>(MyType)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>    </code><code>v.Get()  </code><code>//<br />
 Call the Get method for *MyType.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>6</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>7</code>
</td>
<td>
<code>    </code><code>v<br />
 = </code><code>new</code><code>(MySubType)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>8</code>
</td>
<td>
<code>    </code><code>v.Get()  </code><code>//<br />
 Call the Get method for *MySubType.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>9</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
</td>
<td>
</td>
</tr>
<tr>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h3>类型断言</h3>
<p>用类型断言可以将变量从一个接口类型转变为不同的接口类型。这是在运行时动态实现的。与Java不同,不需要对两个接口之间的关系作任何声明，如：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>type<br />
 Printer interface {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>    </code><code>Print()</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>func<br />
 f4(x MyInterface) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>6</code>
</td>
<td>
<code>    </code><code>x.(Printer).Print()  </code><code>//<br />
 类型断言为 Printer</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>7</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>转换到Printer完全是动态的。 只要x的动态类型(存储在x中的值的实际类型)定义了一个Print方法，它就会工作。</p>
</td>
<td>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<br />
泛型<br />
<br />Go 没有泛型类型,但通过结合匿名字段和类型断言可以实现类似于Java的参数化的类型，如：</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>type<br />
 StringStack </code><code>struct</code> <code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>    </code><code>Stack</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>func<br />
 (s *StringStack) Push(n string) { s.Stack.Push(n) }</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>6</code>
</td>
<td>
<code>func<br />
 (s *StringStack) Pop() string   { </code><code>return</code> <code>s.Stack.Pop().(string)<br />
 }</code>
</td>
</tr>
</tbody>
</table>
<p>StringStack限定<a href="http://www.nada.kth.se/~snilsson/go_for_java_programmers/#Hello" rel="external nofollow noreferrer">Hello stack</a>例子中的泛型Stack,所以它只操作字符串元素——就像Java中的Stack&lt;String&gt; 。注意,Sizemethod继承于Stack。</p>
</td>
<td>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h3>错误</h3>
<p>Java经常使用异常，Go则有两种机制。大多数程序只有真正不能回收的情况下返回错误，比如超出范围的索引，产生一个运行时异常。</p>
<p>Go的多值返回使得返回一个详细的错误消息和正常的返回值十分容易。按照惯例，这些消息有类型错误，一个简单的内置接口。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>type<br />
 error interface {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>    </code><code>Error()<br />
 string</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>举个例子，如果打开文件失败，os.Open函数返回一个非空错误值。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>func<br />
 Open(name string) (file *File, err error)</code>
</td>
</tr>
</tbody>
</table>
<p>下面的代码使用os.Open来打开一个文件。如果遇到错误就会调用log.Fatal来打印错误消息并终止。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>f,<br />
 err := os.Open(</code><code>"filename.ext"</code><code>)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>if</code> <code>err<br />
 != nil {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>    </code><code>log</code><code>.Fatal(err)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>//<br />
 do something with the open *File f</code>
</td>
</tr>
</tbody>
</table>
<p>错误接口只需要一个Error方法，但是特定的错误实现往往会有附加的方法，允许调用者检查详细的错误。</p>
</td>
<td>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h3>Panic和recover</h3>
<p>一个panic是一个运行时刻错误，并释放Go程序的堆栈，同时运行defer程序，最终程序停止。Panic和Java中的异常相似，但它仅仅表明是运行时错误，比如空指针或是数组越界。Go用内建错误类型来描述如访问文件结尾等上述错误信息。 </p>
<p>内建函数recover可用在panic并内恢复Go程序运行，同时recover能停止循环返回参数传递给panic。因为在defer函数里只能运行循环代码，同时revcover只能运行defer函数中。如果Go程序没有panic，recover将返回nil。
</td>
<td>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<p>Go协程和信道</p>
<p><a href="http://www.flickr.com/photos/erikjaeger/35008017/" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTMwNy8xMDE4MTY1OF91RGFXLmpwZw==.jpg"></a><br />
<br />寿司制作流程 </p>
<h3>Go协程</h3>
<p>Go中的线程,使用go声明,执行一个goroutine.并且在不同的,新创建的goroutine中运行该函数.在一个程序中所有的Go协程,共用相同的地址空间.</p>
<p>Go协程是轻量级的,消耗成本只比分配的栈空间多一点,  栈开始时较小并通过堆存储的分配和释放来实现其增长。内部的Go协程像协程一样并存在操作系统的多个线程中。你不必去拘泥于这些细节。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>go<br />
 list.Sort()  </code><code>//<br />
 Run list.Sort in parallel; don’t wait for it.</code>
</td>
</tr>
</tbody>
</table>
<p>Go 拥有函数字面量,可以表现为闭包函数,与go 声明一起使用的话,功能将更为强大.</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>//<br />
 发布后打印文本到标准输出,直到给定的时间过期。</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>func<br />
 Publish(text string, delay </code><code>time</code><code>.Duration)<br />
 {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>    </code><code>go<br />
 func() {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>        </code><code>time</code><code>.Sleep(delay)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>        </code><code>fmt.Println(text)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>6</code>
</td>
<td>
<code>    </code><code>}()  </code><code>//<br />
 注意括号,我们必须调用该函数.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>7</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>变量text和delay在外部函数和闭包(函数字面量)之间共享,只存在于在它们可访问期间。</p>
</td>
<td>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h4>Channels</h4>
<p>channel 通过传递特定元素类型的值,提供了一套两个 goroutines 同步执行及交流的机制。  &lt;-  操作符制定 channel 发送或接收的方向。如果没有明确方向，则通道为双向的。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>chan<br />
 Sushi      </code><code>//<br />
 can be used to send and receive values of type Sushi</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>chan&lt;-<br />
 float64  </code><code>//<br />
 can only be used to send float64s</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>&lt;-chan </code><code>int</code>      <code>//<br />
 can only be used to receive ints</code>
</td>
</tr>
</tbody>
</table>
<p>Channel 为引用类型，使用 make 分配。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>ic<br />
 := make(chan </code><code>int</code><code>)        </code><code>//<br />
 unbuffered channel of ints</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>wc<br />
 := make(chan *Work, 10)  </code><code>//<br />
 buffered channel of pointers to Work</code>
</td>
</tr>
</tbody>
</table>
<p>要向通道传递值，以二进制操作符的方式使用 &lt;- 。要接收数据，则以一元运算符的方式使用它。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>ic<br />
 &lt;- 3       </code><code>//<br />
 Send 3 on the channel.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>work<br />
 := &lt;-wc  </code><code>//<br />
 Receive a pointer to Work from the channel.</code>
</td>
</tr>
</tbody>
</table>
<p>如若 channel 无缓冲区，则发送者堵塞，直到接收者接受到传值。如果 channel 有缓冲区，发送者堵塞，直到接收者开始读取缓冲区；如果缓冲区满了，则需要等到某些接收者开始检索值。接收者堵塞，直到有数据可接收。</p>
<p>close 函数将记录通道不能再被用来发送数据。当调用 close 函数后，在所有先前发送的值都被接收以后，接收操作将不会堵塞，同时返回 0 值。一个多值的接收操作将能够获取到 channel 是否被关闭的指示。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>ch<br />
 := make(chan string)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>go<br />
 func() {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>    </code><code>ch<br />
 &lt;- </code><code>"Hello!"</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>    </code><code>close(ch)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>}()</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>6</code>
</td>
<td>
<code>fmt.Println(&lt;-ch)  </code><code>//<br />
 Print "Hello!".</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>7</code>
</td>
<td>
<code>fmt.Println(&lt;-ch)  </code><code>//<br />
 Print the zero value "" without blocking.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>8</code>
</td>
<td>
<code>fmt.Println(&lt;-ch)  </code><code>//<br />
 Once again print "".</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>9</code>
</td>
<td>
<code>v,<br />
 ok := &lt;-ch      </code><code>//<br />
 v is "", ok is false.</code>
</td>
</tr>
</tbody>
</table>
<p>在下面的例子，我们将使 Publish 函数返回一个通道，它将被用来在文本发表完成后广播消息</p>
<table>
<tbody>
<tr>
<td>
<code>01</code>
</td>
<td>
<code>//<br />
 Publish prints text to stdout after the given time has expired.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>02</code>
</td>
<td>
<code>//<br />
 It closes the wait channel when the text has been published.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>03</code>
</td>
<td>
<code>func<br />
 Publish(text string, delay </code><code>time</code><code>.Duration)<br />
 (wait &lt;-chan </code><code>struct</code><code>{})<br />
 {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>04</code>
</td>
<td>
<code>    </code><code>ch<br />
 := make(chan </code><code>struct</code><code>{})</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>05</code>
</td>
<td>
<code>    </code><code>go<br />
 func() {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>06</code>
</td>
<td>
<code>        </code><code>time</code><code>.Sleep(delay)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>07</code>
</td>
<td>
<code>        </code><code>fmt.Println(text)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>08</code>
</td>
<td>
<code>        </code><code>close(ch)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>09</code>
</td>
<td>
<code>    </code><code>}()</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>10</code>
</td>
<td>
<code>    </code><code>return</code> <code>ch</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>11</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>下面就是 Publish 函数的大概用法</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>wait<br />
 := Publish(</code><code>"important<br />
 news"</code><code>,<br />
 2 * </code><code>time</code><code>.Minute)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>//<br />
 Do some more work.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>&lt;-wait </code><code>//<br />
 blocks until the text has been published</code>
</td>
</tr>
</tbody>
</table>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></p>
<h3>Select语句</h3>
<p>select语句是Go统一工具箱中的最终工具。它选择哪些通信将被处理。如果任何的通信都能处理，那么就会随机选其一，与之对应的语句就会执行。另外，如果没有默认的case，语句就会阻塞直到其中一个通信完成为止。</p>
<p>这里有一个toy的例子，展示了select语句如何用来实现一个随机数发生器。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>rand</code> <code>:=<br />
 make(chan </code><code>int</code><code>)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>for</code> <code>{ </code><code>//<br />
 Send random sequence of bits to rand.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>    </code><code>select<br />
 {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>    </code><code>case</code> <code>rand</code> <code>&lt;-<br />
 0: </code><code>//<br />
 note: no statement</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>    </code><code>case</code> <code>rand</code> <code>&lt;-<br />
 1:</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>6</code>
</td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>7</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>更加现实的是，这里有一个select语句可以用来设置时间限制一个接受操作。</p>
<table>
<tbody>
<tr>
<td>
<code>1</code>
</td>
<td>
<code>select<br />
 {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>2</code>
</td>
<td>
<code>case</code> <code>news<br />
 := &lt;-AFP:</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>3</code>
</td>
<td>
<code>    </code><code>fmt.Println(news)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>4</code>
</td>
<td>
<code>case</code> <code>&lt;-</code><code>time</code><code>.After(</code><code>time</code><code>.Minute):</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>5</code>
</td>
<td>
<code>    </code><code>fmt.Println(</code><code>"Time<br />
 out: no news in one minute."</code><code>)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>6</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>time.After函数式标准库的一部分；它等待一段特定时间后发送当前时间到返回的频道。</p>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<p>并发（示例）</p>
<p>最后我们通过一个小而全的例子展示如何将若干块拼凑在一起。它是一个服务器通过一个频道（channel）接受Work请求（Work request）的草案代码。每一个请求都使用一个单独的渠道进行处理。Work将自身构造包含进一个用来返回结果的频道中。</p>
<table>
<tbody>
<tr>
<td>
<code>01</code>
</td>
<td>
<code>package<br />
 server</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>02</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>03</code>
</td>
<td>
<code>import </code><code>"log"</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>04</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>05</code>
</td>
<td>
<code>//<br />
 New creates a new server that accepts Work requests</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>06</code>
</td>
<td>
<code>//<br />
 through the req channel.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>07</code>
</td>
<td>
<code>func<br />
 New() (req chan&lt;- *Work) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>08</code>
</td>
<td>
<code>    </code><code>wc<br />
 := make(chan *Work)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>09</code>
</td>
<td>
<code>    </code><code>go<br />
 serve(wc)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>10</code>
</td>
<td>
<code>    </code><code>return</code> <code>wc</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>11</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>12</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>13</code>
</td>
<td>
<code>type<br />
 Work </code><code>struct</code> <code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>14</code>
</td>
<td>
<code>    </code><code>Op   <br />
 func(</code><code>int</code><code>, </code><code>int</code><code>) </code><code>int</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>15</code>
</td>
<td>
<code>    </code><code>A,<br />
 B  </code><code>int</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>16</code>
</td>
<td>
<code>    </code><code>Reply<br />
 chan </code><code>int</code>  <code>//<br />
 Server sends result on this channel.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>17</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>18</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>19</code>
</td>
<td>
<code>func<br />
 serve(wc &lt;-chan *Work) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>20</code>
</td>
<td>
<code>    </code><code>for</code> <code>w<br />
 := range wc {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>21</code>
</td>
<td>
<code>        </code><code>go<br />
 safelyDo(w)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>22</code>
</td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>23</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>24</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>25</code>
</td>
<td>
<code>func<br />
 safelyDo(w *Work) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>26</code>
</td>
<td>
<code>    </code><code>//<br />
 Regain control of panicking goroutine to avoid</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>27</code>
</td>
<td>
<code>    </code><code>//<br />
 killing the other executing goroutines.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>28</code>
</td>
<td>
<code>    </code><code>defer<br />
 func() {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>29</code>
</td>
<td>
<code>        </code><code>if</code> <code>err<br />
 := recover(); err != nil {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>30</code>
</td>
<td>
<code>            </code><code>log</code><code>.Println(</code><code>"work<br />
 failed:"</code><code>,<br />
 err)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>31</code>
</td>
<td>
<code>        </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>32</code>
</td>
<td>
<code>    </code><code>}()</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>33</code>
</td>
<td>
<code>    </code><code>do</code><code>(w)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>34</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>35</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>36</code>
</td>
<td>
<code>func </code><code>do</code><code>(w<br />
 *Work) {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>37</code>
</td>
<td>
<code>    </code><code>w.Reply<br />
 &lt;- w.Op(w.A, w.B)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>38</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>而下面这是你如何使用它：</p>
<table>
<tbody>
<tr>
<td>
<code>01</code>
</td>
<td>
<code>package<br />
 server_test</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>02</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>03</code>
</td>
<td>
<code>import<br />
 (</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>04</code>
</td>
<td>
<code>    </code><code>server </code><code>"."</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>05</code>
</td>
<td>
<code>    </code><code>"fmt"</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>06</code>
</td>
<td>
<code>    </code><code>"time"</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>07</code>
</td>
<td>
<code>)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>08</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>09</code>
</td>
<td>
<code>func<br />
 main() {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>10</code>
</td>
<td>
<code>    </code><code>s<br />
 := server.New()</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>11</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>12</code>
</td>
<td>
<code>    </code><code>divideByZero<br />
 := &amp;server.Work{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>13</code>
</td>
<td>
<code>        </code><code>Op:   <br />
 func(a, b </code><code>int</code><code>) </code><code>int</code> <code>{ </code><code>return</code> <code>a<br />
 / b },</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>14</code>
</td>
<td>
<code>        </code><code>A:    <br />
 100,</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>15</code>
</td>
<td>
<code>        </code><code>B:    <br />
 0,</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>16</code>
</td>
<td>
<code>        </code><code>Reply:<br />
 make(chan </code><code>int</code><code>),</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>17</code>
</td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>18</code>
</td>
<td>
<code>    </code><code>s<br />
 &lt;- divideByZero</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>19</code>
</td>
<td>
 </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>20</code>
</td>
<td>
<code>    </code><code>select<br />
 {</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>21</code>
</td>
<td>
<code>    </code><code>case</code> <code>res<br />
 := &lt;-divideByZero.Reply:</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>22</code>
</td>
<td>
<code>        </code><code>fmt.Println(res)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>23</code>
</td>
<td>
<code>    </code><code>case</code> <code>&lt;-</code><code>time</code><code>.After(</code><code>time</code><code>.Second):</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>24</code>
</td>
<td>
<code>        </code><code>fmt.Println(</code><code>"No<br />
 result in one second."</code><code>)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>25</code>
</td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>26</code>
</td>
<td>
<code>    </code><code>//<br />
 Output: No result in one second.</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<code>27</code>
</td>
<td>
<code>}</code>
</td>
</tr>
</tbody>
</table>
<p>并发是一个庞大的话题，而Go的方法和Java的方法时相当不同的。有两篇文章涉及到了这些基础：<br />
<br />并发编程基础（<a href="http://www.nada.kth.se/~snilsson/concurrency/" rel="external nofollow noreferrer">Fundamentals of concurrent programming</a> ）使用Go编写的小例子来介绍并发。</p>
<p>通过交流共享内存（<a href="http://golang.org/doc/codewalk/sharemem/" rel="external nofollow noreferrer">Share Memory by Communicating</a> ）使用更大幅度的例子进行代码走读（codewalk）。</p>
<p><a href="https://plus.google.com/100350950314702566738/about?rel=author" rel="external nofollow noreferrer">Stefan Nilsson</a></p>
<p>文章地址：<a href="http://blog.csdn.net/djy1992/article/details/9668153" rel="external nofollow noreferrer">http://blog.csdn.net/djy1992/article/details/9668153</a></p>
</td>
<td>
</td>
</tr>
</tbody>
</table>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-17 01:58:43</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/type/" title="type">type</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e7%a8%8b%e5%ba%8f%e5%91%98/" title="程序员">程序员</a>, <a href="https://www.iamivan.net/tag/%e8%a1%a8%e8%be%be%e5%bc%8f/" title="表达式">表达式</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java程序员快速入门Go语言的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvKjOWp.html" rel="bookmark">Java程序员ActionScript 3入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们还是勇敢面对吧:客户端对于Java程序员来说,一直都不是个友好的地方 .Java在客户端的技术,包括applet.Swing和JavaFX到目前为止只取得了有限的 成绩.JavaScript除了它的名字外,几乎没有什么地方像Java语言.而Adobe Flash呢,它看起来的确像JavaScript,真的吗?也许在几年前说Flash就像 JavaScript一样是可以理解的,但随着 ActionScript 3的出现,一切都改变了. 而且我相信你会喜欢它的很多东西. 首先,ActionScr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnKKRKz.html" rel="bookmark">Kotlin 喧嚣过后，谈谈 Java 程序员未来的出路</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				自从谷歌 I/O 2017宣布将支持 Kotlin 作为 Android 开发的 First-Class 语言,各种 Kotlin 能否取代 Java 的文章.争论层出不穷. 作为一名老 Java 程序员,心态是比较复杂的,虽然类似场面见过不少. 早在 2009 年,就有了 Scala 是否是 Java 后继者的争论. 2009年7月 InfoQ 发表的一篇文章:「Roundup: Scala as the long term replacement for Java」,还谈到了 Java 之父			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm3Y83b.html" rel="bookmark">寻觅优秀Java程序员何其难</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java开发者供大于求,找一个优秀的开发者犹如大海捞针.这该赖谁?赖程序员对Java没兴趣吗?还是赖瞎了眼的招聘?抑或是语言本身?不管你同意与否,下面就列举了和这个问题相关的答案. 问题非语言,而是程序员自身 大多程序员都想做与众不同的人,大家都喜欢尝试.但除此之外,更多的程序员想要一个薪水丰厚的工作.最简单的方式就是学习Java--不管自己喜不喜欢写,这就是为什么众多无工作激情的程序员都沦为了Java程序&quot;猿&quot;. &quot;我不是指所有的Java程序员都是无能之辈&quot;,博客			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxPG40M.html" rel="bookmark">Java程序员在写SQL程序时候常犯的10个错误</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  Java程序员编程时需要混合面向对象思维和一般命令式编程的方法,能否完美的将两者结合起来完全得依靠编程人员的水准: 技能(任何人都能容易学会命令式编程) 模式(有些人用&quot;模式-模式&quot;,举个例子,模式可以应用到任何地方,而且都可以归为某一类模式) 心境(首先,要写个好的面向对象程序是比命令式程序难的多,你得花费一些功夫) 但当Java程序员写SQL语句时,一切都不一样了.SQL是说明性语言而非面向对象或是命令式编程语言.在SQL中要写个查询语句是很简单的.但在Java里类似的语句却不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1lNkjb.html" rel="bookmark">C&plus;&plus;程序员和Java程序员的差异</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先说明,这几年接触的最多的程序员就是C++程序员和Java程序员,这只是我自己的一点体会而已,一个人的眼光难免是浅薄的.不过,欢迎拍砖,也欢迎对号入座.   从对基础知识掌握的程度来说,例如数据结构和算法,C++程序员要比Java程序员牢靠得多.究其原因,大概是因为C++程序员需要经常自己实现那些项目基础设施,但是Java程序员大多拿来即用.公平地说,C++不是一门适合程序员初学者的语言,但是Java是.C++程序看起来确实要比Java 程序稍难懂一些,C++程序员往往思维更加严密.另一方面,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Zj57z.html" rel="bookmark">Java程序员使用哪些大数据开发工具？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这是作者在另一个帖子中发布的一项近期调查结果,调查为作者询问一些Java程序员,其在12个月内使用了什么框架开发工具.本次调查中覆盖了大数据工具. 以下是调查所覆盖的主题: 1.语言 2.Web框架 3.应用服务器 4.SQL数据访问工具 5.SQL数据库 6.大数据 7.构建工具 8.云提供商 今天让我们来看看大数据. 根据维基百科,大数据是一个广义的术语,所包含的的内容十分庞大且复杂,以至于传统的数据处理应用程序根本不足以应对. 在许多情况下,使用SQL数据库用于存储/检索数据已经足够了.但			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0n8n6z.html" rel="bookmark">深受Java程序员欢迎的10款Java IDE</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java是全世界最受欢迎的一门程序语言,它被广泛的应用于企业项目.游戏设计.安卓应用程序等开发领域.以下的列表是整理的近些年来深受Java程序员欢迎的10款Java IDE.(注:IDE意为集成开发环境,它不仅支持编辑和编译代码,还能够完成管理资源.提供部署.版本控制等工作.) NetBeans NetBeans是过去10年发展最好的IDE,它做到了完全的模块化 ,所有的IDE功能都被封装成包,并称之为模块.它提供了简单的方式来集成版本控制软件.由于它的源代码已经被Sun公司开源,因此在任意平台			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1NZR5p.html" rel="bookmark">Java程序员学习流程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 对Java很感兴趣,现在在学j2se,想知道怎样才能成为一名合格的java程序员呢? 解决方案 解决方案二:我一直用的java,简单说说我的想法,仅供参考.我一开始学java的时候是看基础书籍,理解了基础知识后,我就进入公司开始做项目了.那时候懂得很少,在做项目的过程中自己去慢慢学的.老实说自己去看书真的没有在项目中得到的锻炼多.等有一定的项目经验后,有时候回过头来再看看这些书籍,理解就会加深很多.还有补充一点,等你在项目中遇到这样那样的问题,在你解决问题的过程中,你就会不知不觉地学会			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWG4LGM.html" rel="bookmark">Java的JNI快速入门教程&lpar;推荐&rpar;&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. JNI简介 JNI是Java Native Interface的英文缩写,意为Java本地接口. 问题来源:由于Java编写底层的应用较难实现,在一些实时性要求非常高的部分Java较难胜任(实时性要求高的地方目前还未涉及,实时性这类话题有待考究). 解决办法:Java使用JNI可以调用现有的本地库(C/C++开发任何和系统相关的程序和类库),极大地灵活Java的开发. 2. JNI快速学习教程 2.1 问题: 使用JNI写一段代码,实现string_Java_Test_helloworld			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWXg7p.html" rel="bookmark" class="title">影响中国软件20人</a>
					<div>
						[1]严援朝 所属公司:新浪网 入选理由:开发第一个中文操作系统CCDOS,参与创办四通利方,掌控最大的中文网站新浪网技术总架构. &quot;做软件就是在不断地明确目标,就是搞清楚你的GO 是什么, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdYe4z.html" rel="bookmark" class="title">全面升级您的Flash播放器</a>
					<div>
						flash播放 大家都知道,播放Flash文件时我们无法像视频文件那样自由地控制播放进度,甚至有时到了一些精彩的地方,想暂停下来都特别不方便,每次都得去菜单里执行,搞不好就延误了精彩的瞬间,抓不住最动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMR5dGb.html" rel="bookmark" class="title">Flash动画下载助手FlashCatcher</a>
					<div>
						flash动画|下载 在上网浏览页面的时候,看到页面上漂亮的Flash动画,很想把它保存到本地以便日后慢慢欣赏,可是大部分页面都进行了加密,对Flash动画的下载做了保护使其下载变的相对复杂起来.难道 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AV3np.html" rel="bookmark" class="title">iPad用户如何使用Mac和Windows应用软件：Parallels Access使用体验</a>
					<div>
						用ipad远程连接win系统已不是新鲜事情,我们可以使用TeamViewer和OnLiveDesktopPlus等软件,那么如何即能显示Win系统还能显示MAC系统还能保留苹果特有的所有iOS触摸手势 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAaXm2M.html" rel="bookmark" class="title">使用Apache Pivot构建iTunes搜索客户端</a>
					<div>
						使用 WTKX 和 Java 技术构建富 Internet 应用程序 开始之前 常用术语 Ajax:异步 JavaScript + XML API:应用编程接口 CSV:逗号分隔的值 GUI:图形用户 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M915gVM.html" rel="bookmark" class="title">ZhengTu盗号木马bdscheca001&period;dll的清除方法</a>
					<div>
						添加启动项 [HKEY_LOCAL_MACHINESOFTWAREMicrosoftWindowsCurrentVersionExplorerShellExecuteHooks] {9C0CFA58- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91ZJvM.html" rel="bookmark" class="title">PPT如何设置自动恢复功能</a>
					<div>
						  1.在PPT中选择&quot;工具&quot;→&quot;选项&quot;. 2.切换到&quot;保存&quot;选项中,选中&quot;保存自动恢复信息&quot;,设置自动恢复的保存频率, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNY3WM.html" rel="bookmark" class="title">Photoshop制作蓝色圆珠笔手绘花朵照片</a>
					<div>
						  本教程主要使用Photoshop简单方法制作圆珠笔画效果,这种手绘的效果非常的实用漂亮,喜欢的朋友让我们一起来学习吧. 先看一下显示的最终效果 1.新建文件导入一个笔记本的背景 2.将要做效果的图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eAqYb.html" rel="bookmark" class="title">如何用Word抠图或去除背景色</a>
					<div>
						  说到抠图估计大家能立马想到的不是word而是PS,但是今天blue1000跟大家讲的确实是如何用Word抠图或去除背景色的教程.其实在word里抠图也是常用的技巧之一.为了让图片能融入文档中抠图也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eyJAb.html" rel="bookmark" class="title">win7系统怎么禁止网页播放背景音乐？</a>
					<div>
						  相信有很多用户都习惯一边听音乐一边浏览网页,但是当我们打开网页时可能会传出一些不和谐的背景声音,让整个音乐变得很嘈杂,那么有什么方法能够禁止网页播放背景音乐呢,下面小编跟大家分享下如何禁止播放网页 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZEwJz.html" rel="bookmark" class="title">wallpaper engine不可用解决方法</a>
					<div>
						  wallpaper engine不可用怎么办? 不可用时如下图: 首先确认您的网络状况良好,然后退出软件与Steam,重新开启steam,由steam开启软件而不是由文件根目录. 然后使用stea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGlL1p.html" rel="bookmark" class="title">系统之家Win7旗舰版系统中误删U盘文件的恢复秘籍</a>
					<div>
						一.准备工作: 下载并安装顶尖数据恢复软件 二.操作步骤 1.把u盘与电脑相连接,然后运行顶尖数据恢复软件. 2.在顶尖数据恢复软件左侧选中u盘的盘符. 3.单击工具栏上的&quot;快速扫描&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3B1EM.html" rel="bookmark" class="title">向云服务器上传下载文件方法汇总</a>
					<div>
						一.向Windows服务器上传下载文件方式  方法有很多种,此处介绍远程桌面的本地资源共享方法. 1.运行mstsc,连接远程桌面的时候,点&quot;选项&gt;&gt;&quot; 2.&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72yArp.html" rel="bookmark" class="title">ios-最好的方法知道view的设置方向</a>
					<div>
						问题描述 最好的方法知道view的设置方向 需要检测当前View的设置方向.那个方法更好一点? [[UIDevice currentDevice]orientation] [[UIApplicatio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eXjyb.html" rel="bookmark" class="title">Android Moveview滑屏移动视图类完整实例&lowbar;Android</a>
					<div>
						本文示例所述程序为一个Android Moveview移动视图类.其主要实现主屏左右滑屏拖动功能,并适时显示拖动时候屏幕的显示情况,该代码中还包括完整的逻辑.其完整代码如下: import andro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32l5Jz.html" rel="bookmark" class="title">汉字拼音列表分享</a>
					<div>
						汉字拼音列表分享 a ai an ang ao ba bai ban bang bao bei ben beng bi bian biao bie bin bing bo bu ca cai can  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEykYp.html" rel="bookmark" class="title">从源代码编译 Vim 8&period;0</a>
					<div>
						从源代码编译 Vim 实际上并不那么困难.下面是你所要做的: 1.首先,安装包括 Git 在内的所有必备的库.对于一个 Debian 类的 Linux 发行版,例如 Ubuntu,命令如下: sudo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZZvrp.html" rel="bookmark" class="title">全球第二大IT代工厂伟创力北京公司裁员30&percnt;</a>
					<div>
						腾讯科技讯 11月28日晚消息,知情人士透露,全球第二大电子合约制造服务商(EMS)伟创力正在大举展开裁员.其在北京开发部门全部被裁,部门经理也未能幸免.同时,其在北京的其它部门也将裁员30%. 全球 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKL66b.html" rel="bookmark" class="title">中国制造2025新机遇 机器视觉行业爆发</a>
					<div>
						随着我国传统制造业的结构调整和转型升级,高端.精密.自动化和智能化是制造业发展的新趋势, 机器视觉行业也在中国市场度过了发展的最初时期,不仅国际知名品牌纷纷在中国开展业务,中国本土的企业也逐渐兴起.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7ELnp.html" rel="bookmark" class="title">&lpar;急&rpar;现需定时访问一个界面，获取界面里某些数据&quest;</a>
					<div>
						问题描述 现有如下需求:在后台需要定时访问某个界面如:(外网地址 http://www.zhcw.com/ssq/kjgg/zuixinkaijiang/) 要获取界面里的相关内容,跪求解决方案. 解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZjoWM.html" rel="bookmark" class="title">csr8510芯片-在pc端通过编程操作CSR蓝牙芯片接收器从而接收蓝牙设备的数据</a>
					<div>
						问题描述 在pc端通过编程操作CSR蓝牙芯片接收器从而接收蓝牙设备的数据 之前我是使用TI的CC2541,在PC端编程发送TI提供的GAP命令来使芯片接收器与蓝牙设备通信,现在想要改为体积很小的CSR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBoxDb.html" rel="bookmark" class="title">培训机构如何实现网上招生</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 以前我是做培训的,后来慢慢转型,改 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWJ8XM.html" rel="bookmark" class="title">惠普一直折腾&comma;何时突破逆成长</a>
					<div>
						在我印象中,失去了卡莉的惠普,就一直在折腾中分分合合.曾经的蓝色巨人,不知不觉也陷入了一种&quot;逆成长&quot;. 25日早上,惠普发布了2015财年第一财季财报.报告显示,惠普第一财季净营收 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyejldM.html" rel="bookmark" class="title">铁血网需要建立可持续的商业模式</a>
					<div>
						摘要: 和那些喜欢夸夸其谈的互联网公司老总不同,今年刚刚30岁的铁血网CEO蒋磊有着和年龄不符的稳重和坦承,所以铁血网的企业气质,也与其本人的性格有着近似之处.尽管铁血网的电商 和那些喜欢夸夸其谈的互 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV7wd4b.html" rel="bookmark" class="title">CES 2011：内置投影机的Android装置</a>
					<div>
						这款Android装置,看起来很像手机,但厂商宣称它为 &quot;Android mini tablet&quot; ,因为他没有内置3G网络,这款平板最大的特色就是内置微型投影机,不过厂商强调这是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYWBAb.html" rel="bookmark" class="title">谷歌宣布正在研发新型移动支付框架</a>
					<div>
						3月3日消息 据国外媒体报道,谷歌宣布公司正在研发一个名为安卓支付(Android Pay)的新型移动支付框架.负责Android.Chrome和谷歌应用程序的谷歌业务副总裁桑达尔·皮采(Sundar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrvkkp.html" rel="bookmark" class="title">makecert生成X509证书怎么更新有效期</a>
					<div>
						问题描述 如题,使用windows的系统工具makecert.exe创建了X509证书,现在证书有效期快到了,请问有没有办法不生成新的证书,将原来的证书的有效期更新呢? 解决方案 解决方案二:自己顶起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVJZDz.html" rel="bookmark" class="title">头像何时支持</a>
					<div>
						问题描述 以后会支持头像功能吧?:) 解决方案 环信只是即时通讯的消息引擎.环信本身不提供用户体系,环信既不保存任何APP业务数据,也不保存任何APP的用户信息.比如说, 你的APP是一个婚恋交友AP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdvPR6b.html" rel="bookmark" class="title">Java可见性机制的原理</a>
					<div>
						基本概念 1.可见性 当一个线程修改了共享变量时,另一个线程可以读取到这个修改后的值. 2.内存屏障(Memory Barriers) 处理器的一组指令,用于实现对内存操作的顺序限制. 3.缓冲行 C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVdJlVM.html" rel="bookmark" class="title">我要购买一域名&period;&period;&period;对方真是&amp;amp&semi;amp&semi;quot&semi;幽默&amp;amp&semi;amp&semi;quot&semi;</a>
					<div>
						问题描述 前几天一个朋友想做个IT站玩玩.然后搜了一大堆米,居然看中一个垃圾/ITzhongguo.com长达10位的域名...以一个域名投资者的眼光来看,这个域名真的很垃圾.如果不做站,光投资,10 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.054 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
